exec("./Profiles/bars.cs");
exec("./Profiles/fonts.cs");
exec("./Gravebreak_HUD.gui");
exec("./Gravebreak_NewMsg.gui");

package GB_spawnChanges
{
	function PlayGUI::onWake(%this)
	{
		parent::onWake(%this);
		if($GB::isOnGBServer)
		{
			schedule(100,0,GB_makeChanges);
		}
	}
};
activatePackage(GB_spawnChanges);

function GB_revertChanges()
{
	HUD_BrickBox.setVisible(1);
	HUD_BrickNameBG.setVisible(1);
	HUD_ToolBox.setBitmap("base/client/ui/toolicons/ToolBG.png");
	HUD_ToolNameBG.setBitmap("base/client/ui/toolicons/ToolLabelBG.png");
	HUD_paintBox.setVisible(1);
	HUD_PaintNameBG.setVisible(1);
	GB_noticeBlimp.setVisible(1);
	newChatText.setVisible(1);
	chatWhosTalkingText.setVisible(1);
	chatScrollDownIndicator.setVisible(1);
	$GB::isOnGBServer = 0;
	PlayGUI.remove(Gravebreak_HUD);
}

function GB_makeChanges()
{
	HUD_BrickBox.setVisible(0);
	HUD_BrickNameBG.setVisible(0);
	HUD_ToolBox.setBitmap("Add-ons/Client_Gravebreak/Images/ToolBGReskin.png");
	HUD_ToolNameBG.setBitmap("Add-ons/Client_Gravebreak/Images/ToolLabelBGReskin.png");
	HUD_paintBox.setVisible(0);
	HUD_PaintNameBG.setVisible(0);
	PlayGUI.add(Gravebreak_HUD);
	GB_noticeBlimp.setVisible(0);
	newChatText.setVisible(0);
	chatWhosTalkingText.setVisible(0);
	chatScrollDownIndicator.setVisible(0);
	Gravebreak_HUD.resize(0,0,getWord(PlayGUI.getExtent(),0),getWord(PlayGUI.getExtent(),1));
}

function clientCmdGB_setThirst(%val)
{
	GB_ThirstBar.setValue(%val);
}

function clientCmdGB_setHunger(%val)
{
	GB_HungerBar.setValue(%val);
}

function clientCmdGB_setHealth(%val)
{
	GB_HealthBar.setValue(%val);
}

function clientCmdGB_notice(%title,%text,%time)
{
	GB_noticeBlimp_Title.setValue(%title);
	GB_noticeBlimp_Text.setValue(%text);
	GB_noticeBlimp.setVisible(1);
	GB_noticeBlimp.schedule(%time @"000",setVisible,0);
}

function GB_Chat_ChatText::addChatLine(%this,%line)
{
	$GB::ChatText6 = $GB::ChatText5;
	$GB::ChatText5 = $GB::ChatText4;
	$GB::ChatText4 = $GB::ChatText3;
	$GB::ChatText3 = $GB::ChatText2;
	$GB::ChatText2 = $GB::ChatText1;
	$GB::ChatText1 = %line;
	
	%text = $GB::ChatText6 @ "\n" @ $GB::ChatText5 @ "\n" @ $GB::ChatText4 @ "\n" @ $GB::ChatText3 @ "\n" @ $GB::chatText2 @ "\n"@$GB::chatText1;
	
	GB_Chat_ChatText.setValue(%text);
}

function GB_Chat()
{
	%text = GB_Chat_EditCtrl.getValue();
	if($GB::globalChat)
	{
		GB_Chat_EditCtrl.setValue("");
		commandToServer('teamMessageSent',%text);
		Canvas.popDialog(Gravebreak_NewMsg);
	}
	else
	{
		GB_Chat_EditCtrl.setValue("");
		commandToServer('messageSent',%text);
		Canvas.popDialog(Gravebreak_NewMsg);
	}
}

function clientCmdGB_clientAuthCheck()
{
	commandToServer('GB_ClientAuthCheckComplete');
	$GB::isOnGBServer = 1;
}

function GB_fixResolution()
{
	Gravebreak_HUD.resize(0,0,getWord(PlayGUI.getExtent(),0),getWord(PlayGUI.getExtent(),1));
}

package GB_Client
{
	function resetCanvas()
	{
		parent::resetCanvas();
		schedule(1000,0,GB_fixResolution);
	}
	function disconnect()
	{
		if($GB::isOnGBServer)
			GB_revertChanges();
		parent::disconnect();
	}
	
	function GlobalChat(%bool)
	{
		if($GB::isOnGBServer && %bool)
		{
			$GB::globalChat = 0;
			canvas.pushDialog(GraveBreak_NewMsg);
			GB_Chat_talk.setValue("Local:");
			return;
		}
		parent::GlobalChat(%bool);
	}
	
	function TeamChat(%bool)
	{
		if($GB::isOnGBServer && %bool)
		{
			$GB::globalChat = 1;
			canvas.pushDialog(GraveBreak_NewMsg);
			GB_Chat_talk.setValue("Global:");
			return;
		}
		parent::TeamChat(%bool);
	}
	
	function NewChatSO::addLine(%this,%line)
	{
		parent::addLine(%this,%line);
		if($GB::isOnGBServer)
			GB_Chat_ChatText.addChatLine(%line);
	}
};
activatePackage(GB_Client);